/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

/* Software by P.J.Sloetjes. */

"use strict";

(() => { const
	modules = {},
	file = Components.stack.filename,
	id = file.split(/\//g)[2],
	path = "resource://" + id + "/",
	rid = file.split(/\?/g)[1],
	log = (str) => content && content.console.log(str),
	{ classes: Cc, interfaces: Ci, utils: Cu } = Components,
	send = (win, fun, arg) =>
		win && win.QueryInterface(Ci.nsIInterfaceRequestor).
				getInterface(Ci.nsIDocShell).
				QueryInterface(Ci.nsIInterfaceRequestor).
				getInterface(Ci.nsIContentFrameMessageManager).
				sendAsyncMessage(id, { fun, arg }),
	receive = (msg) => { const
		dat = msg.data, nam = dat.mod || "", mod = nam && modules[nam];
		switch (dat.fun) {
			case "state": state(dat.arg); break;
			case "start": mod ? stop(nam) : nam && start(nam, dat.arg || {}); break;
			case "listen": dat.arg && listen(mod, dat.arg.evt, dat.arg.bool); break;
			case "stop": stop(nam); break;
			case "exit": nam || exit(); break;
			default: if (mod && (msg = dat.fun) && (msg = mod[msg]) && content)
				msg(content.document, dat.arg);
		}
	},
	listen = (mod, evt, bool) =>
		evt && mod && mod[evt] && (!!bool ? 
				addEventListener(evt, mod[evt]) :
				removeEventListener(evt, mod[evt])),
	state = (arg) => { const
		doc = content && content.document,
		sta = { arg, uri: doc && doc.documentURI, rid: doc && doc[id] };
		for (let nam in modules)
			sta[nam] = (modules[nam].state && modules[nam].state(doc)) || 1;
		send(content, "state", sta);
	},
	start = (nam, dat) => {
		Cu.import(path + nam + ".jsm?" + rid, modules);
		content && (content.document[id] = rid);
		const mod = modules[nam];
		if (content && mod) {
			mod.start(dat, content, docShell, { 
					send, stop, log, Sv: Services, 
					Cc, Ci, Cu, rid });
		}
		state({ start: nam });
	},
	stop = (nam) => { const
		mod = modules[nam];
		if (content && mod)
			mod.stop(content, docShell);
		//Cu.unload(path + nam + ".jsm?" + rid);
		delete modules[nam];
		state({ stop: nam });
	},
	exit = () => {
		removeMessageListener(id, receive);
		for (let nam in modules)
			stop(nam);
	};
	addMessageListener(id, receive);
	Cu.import("resource://gre/modules/Services.jsm", this);
	send(content, "start", null);
})();
